#include <stdlib.h>
#include <stdio.h>
#include "basic.h"
#include "barrier.h"

barrier_t *alloc_sense_barrier(unsigned int nprocs) {
  barrier_t *p = malloc_check(sizeof(*p)) ;
  p->nprocs = p->count = nprocs ;
  p->sense = 0 ;
  return p ;
}

void free_sense_barrier(barrier_t *p) {
  free(p) ;
}

/* Coded in C */
void wait_sense_barrier(barrier_t *p) {
  int sense = p->sense ;
  int rem = DECR(&p->count) ;
  SYNC() ;
  if (rem == 0) {
    p->count = p->nprocs ;
    SYNC() ;
    p->sense = !sense ;
  } else {
    while (p->sense == sense) ;
  }
  SYNC() ;
}
