#include <stdlib.h>
#include <stdio.h>
#include "basic.h"

static int verbose = 0 ;


typedef struct {
  int size ;
  volatile int *x,*y,*r0;
} common_t ;

typedef struct {
  int id ;
  common_t *common ;
} ctx_t ;


void *T1(void *_p) {
  ctx_t *p = _p ;
  common_t *q = p->common ;
  int size = q->size ;
  for (int k = size-1 ; k >= 0 ; k--) {
    q->x[k] = 1 ;
    q->y[k] = 1 ;
  }
  return NULL ;
}

void *T2(void *_p) {
  ctx_t *p = _p ;
  common_t *q = p->common ;
  int size = q->size ;
  for (int k = size-1 ; k >= 0 ; k--) {
    q->y[k] = 2 ;
    int r0 = q->x[k] ;
    q->r0[k] = r0 ;
  }
  return NULL ;
}


void run(int size) {
  int count[3][2] ;
  for (int i = 0 ; i < 3  ; i++)
    for (int j = 0 ; j < 2  ; j++)
      count[i][j] = 0 ;
  int *x = calloc(size,sizeof(x[0])) ;
  int *y = calloc(size,sizeof(y[0])) ;
  int *r0 = calloc(size,sizeof(r0[0])) ;
  int nrun = 0 ;
  for ( ; ; ) {
    for (int k = 0 ; k < size ; k++) {
      x[k] = y[k] = 0 ;
      r0[k] = -1 ;
    }
    common_t c ;
    c.size = size ; c.x = x ; c.y = y ; c.r0 = r0 ;
    pthread_t th1,th2 ;
    ctx_t a1,a2 ;
    
    a1.id = 1 ; a1.common = &c ;
    create_thread(&th1,T1,&a1) ;
    a2.id = 2 ; a2.common = &c ;
    create_thread(&th2,T2,&a2) ;
    join_thread(&th1) ;
    join_thread(&th2) ;
    nrun += size ;
    for (int k = 0 ; k < size ; k++) {
      count[y[k]][r0[k]]++ ;
    }
    printf("**********\n") ;
    int nz = 0 ;
    for (int k1 = 1; k1 < 3; k1++)
      for (int k2 = 0 ; k2 < 2 ; k2++) {
        int c = count[k1][k2] ;
        if (c > 0) nz++ ;
        printf("%-6i%c> y=%i; r0=%i\n",c,(k1 == 2 && k2 ==0 ? '*' : ':'),k1,k2) ;
      }
    if (nz == 4) {
      printf("Found all states in %i iterations\n",nrun) ;
      break ;
    }
  }
  free(x) ; free(y) ; free(r0) ;
}


void usage(char *pgm) {
  fprintf(stderr,"Usage: %s [-v]* [n]\n",pgm) ;
}

int main(int argc, char **argv) {
  char * pgm = argv[0] ;
  int size = SIZE ;

  ++argv ;
  --argc ;
  while (argc > 0) {
    char *arg = *argv ;
    if (*arg == '-') {
      arg++ ;
      if (*arg == 'v') verbose++ ;
      else usage(pgm) ;
    } else {
      break ;
    }
    ++argv;
    --argc ;
  }
  if (argc == 1) {    
    size = atoi(argv[0]) ;
  }
  run(size) ;
  return 0 ;
}
